typedef unsigned int size_t;

enum
{
  _ISspace = (1 << ( 5 )) ,	 
};


extern __const unsigned short int *__ctype_b;	 
typedef struct _IO_FILE FILE;

struct alias_map
{
  const char *alias;
  const char *value;
};


static char *string_space = ((void *)0) ;
static size_t string_space_act = 0;
static size_t string_space_max = 0;
static struct alias_map *map;
static size_t nmap = 0;
static size_t maxmap = 0;


static size_t
read_alias_file (fname, fname_len)
     const char *fname;
     int fname_len;
{
  FILE *fp;
  char *full_fname;
  size_t added;
  static const char aliasfile[] = "/locale.alias";


  added = 0;
  while (! feof_unlocked ( fp ) )
    {
      char buf[8192   ];
      char *alias;
      char *value;
      char *cp;

      if (fgets_unlocked ( buf ,   sizeof buf ,   fp )  == ((void *)0) )
	 
	break;

      if (strchr (buf, '\n') == ((void *)0) )
	{
	  char altbuf[8192   ];
	  do
	    if (fgets_unlocked ( altbuf ,   sizeof altbuf ,   fp )  == ((void *)0) )

	      break;
	  while (strchr (altbuf, '\n') == ((void *)0) );
	}


      cp = buf;
       
      while ((__ctype_b[(int) ( ( cp[0] ) )] & (unsigned short int)   _ISspace )  )
	++cp;

       
      if (cp[0] != '\0' && cp[0] != '#')
	{
	  alias = cp++;
	  while (cp[0] != '\0' && ! (__ctype_b[(int) ( ( cp[0] ) )] & (unsigned short int)   _ISspace )  )
	    ++cp;
	   
	  if (cp[0] != '\0')
	    *cp++ = '\0';

	   

	  if (cp[0] != '\0')
	    {
	      size_t alias_len;
	      size_t value_len;

	      value = cp++;
	      if (cp[0] == '\n')
		{
		   


		  *cp++ = '\0';
		  *cp = '\n';
		}
	      else if (cp[0] != '\0')
		*cp++ = '\0';

	      if (nmap >= maxmap)
		extend_alias_table ();

	      alias_len = strlen (alias) + 1;
	      value_len = strlen (value) + 1;

	      if (string_space_act + alias_len + value_len > string_space_max)
		{
		   
		  size_t new_size = (string_space_max
				     + (alias_len + value_len > 1024
					? alias_len + value_len : 1024));
		  char *new_pool = (char *) realloc (string_space, new_size);
		  if (new_pool == ((void *)0) )
		    {
		       ;
		      return added;
		    }
		  string_space = new_pool;
		  string_space_max = new_size;
		}

// #if 0
	      map[nmap].alias = memcpy (&string_space[string_space_act],
					alias, alias_len);
	      string_space_act += alias_len;
// #endif

	      map[nmap].value = memcpy (&string_space[string_space_act],
					value, value_len);
	      string_space_act += value_len;

	      ++nmap;
	      ++added;
	    }
	}
    }

   

  fclose (fp);

  if (added > 0)
    qsort (map, nmap, sizeof (struct alias_map),
	   (int (*)  (const void *, const void *)  ) alias_compare);

   ;
  return added;
}

